#接口类型：互亿无线语音通知接口。
#账户注册：请通过该地址开通账户http://sms.ihuyi.com/register.html
#注意事项：
#（1）调试期间，请仔细阅读接口文档；
#（2）请使用APIID（查看APIID请登录用户中心->语音通知->产品总览->APIID）及APIkey来调用接口；
#（3）该代码仅供接入互亿无线语音通知接口参考使用，客户可根据实际需要自行编写；
  
#!/usr/local/bin/python
#-*- coding:utf-8 -*-
import httplib
import urllib

host  = "http://api.vm.ihuyi.com"
sms_send_uri = "/webservice/voice.php?method=Submit"

#//用户名是登录用户中心->语音通知->产品总览->APIID
account  = "用户名" 
#密码 查看密码请登录用户中心->语音通知->产品总览->APIKEY
password = "密码"

def send_sms(text, mobile):
    params = urllib.urlencode({'account': account, 'password' : password, 'content': text, 'mobile':mobile,'format':'json' })
    headers = {"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}
    conn = httplib.HTTPConnection(host, port=80, timeout=30)
    conn.request("POST", sms_send_uri, params, headers)
    response = conn.getresponse()
    response_str = response.read()
    conn.close()
    return response_str 

if __name__ == '__main__':

    mobile = "138xxxxxxxx"
    text = "您的订单号是：0648。已由顺风快递发出，请注意查收。"

    print(send_sms(text, mobile))